CREATE DATABASE seguros;

USE seguros;

CREATE TABLE agentes (
  AG_ID int UNSIGNED NOT NULL auto_increment,
  login char(16) NOT NULL UNIQUE,
  password char(16) binary NOT NULL,
  nombre varchar(50) NOT NULL,
  telf int,
  DNI int UNIQUE,
  mail varchar(30),
  PRIMARY KEY (AG_ID)
) TYPE=MyISAM;


CREATE TABLE clientes (
  CL_ID int UNSIGNED NOT NULL auto_increment,
  login char(16) NOT NULL UNIQUE,
  AG_ID int UNSIGNED NOT NULL,
  password char(16) binary NOT NULL,
  nombre varchar(50) NOT NULL,
  telf int,
  DNI int UNIQUE,
  mail varchar(30),
  PRIMARY KEY (CL_ID)
) TYPE=MyISAM;


CREATE TABLE polizas (
  PO_ID int UNSIGNED NOT NULL,
  CL_ID int UNSIGNED NOT NULL,
  matricula char(6) NOT NULL UNIQUE,
  modelo varchar(30) NOT NULL,
  valor int UNSIGNED NOT NULL,
  coste int UNSIGNED NOT NULL,
  PRIMARY KEY (PO_ID)
) TYPE=MyISAM;


CREATE TABLE partes_internos (
  PI_ID int UNSIGNED NOT NULL auto_increment,
  PO_ID int UNSIGNED NOT NULL,
  poliza_causante int UNSIGNED NOT NULL,
  estado ENUM ('INITIAL','RESOLVED','VALIDATED','REJECTED') default 'INITIAL',
  descripcion text NOT NULL,
  fecha date NOT NULL,
  hora time NOT NULL,
  indemnizacion int default 0,
  descripcion_rechazo text,
  PRIMARY KEY (PI_ID)
) TYPE=MyISAM;


CREATE TABLE partes_externos (
  PE_ID int UNSIGNED NOT NULL auto_increment,
  id_parte_externo varchar(50) NOT NULL,
  compania_acusadora int NOT NULL,
  PO_ID int UNSIGNED NOT NULL,
  estado ENUM ('INITIAL','RESOLVED','VALIDATED','REJECTED') default 'INITIAL',
  descripcion text NOT NULL,
  fecha date NOT NULL,
  hora time NOT NULL,
  indemnizacion int default 0,
  descripcion_rechazo text,
  PRIMARY KEY (PE_ID)
) TYPE=MyISAM;


CREATE TABLE compania (
  CO_ID int UNSIGNED NOT NULL,
  nombre varchar(80) NOT NULL,
  URLweb varchar(100) NOT NULL,
  URLicono varchar(100) NOT NULL,
  URLproxy varchar(100) NOT NULL,
  Homer varchar(100) NOT NULL,
  DTD varchar(100) NOT NULL,
  PRIMARY KEY (CO_ID)
) TYPE=MyISAM;



CREATE TABLE administrador (
  ADM_ID int UNSIGNED NOT NULL auto_increment,
  login char(16) NOT NULL UNIQUE,
  password char(16) binary NOT NULL,
  nombre varchar(50) NOT NULL,
  telf int,
  DNI int UNIQUE,
  mail varchar(30),
  PRIMARY KEY (ADM_ID)
) TYPE=MyISAM;

INSERT INTO compania VALUES ('666', 'Thunder Seguros OnLine', 'http://192.168.0.4:8080/seguros/','http://192.168.0.4:8080/seguros/images/icon.png', 'http://192.168.0.4:8080/seguros/CallCenter','http://192.168.0.4:8080/osdc/Homer', 'http://192.168.0.4:8080/seguros/osdc.dtd');

INSERT INTO administrador VALUES ('','admin',PASSWORD('hola'),'Steve Jobs', '65548979','47758992','sbc.ge@estudiants.urv.es');

INSERT INTO agentes VALUES ('','agente',PASSWORD('hola'),'Bob Grinberg', '23543979','12358992','sbc.ge@estudiants.urv.es');

INSERT INTO clientes VALUES ('','cliente','1',PASSWORD('hola'),'Sarah Montain', '12348979','44355392','sbc.ge@estudiants.urv.es');


# PRUEBAS
INSERT INTO clientes VALUES ('','cliente2','1',PASSWORD('hola'),'John Ripper', '987654321','66353321','sbc.ge@estudiants.urv.es');
INSERT INTO polizas VALUES (6661, 1, '1258-T', 'Seat', 1200, 300);
INSERT INTO polizas VALUES (6662, 2, '2235-S', 'Fiat', 900, 250);
INSERT INTO partes_internos VALUES ('1','6661','6662','INITIAL','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_internos VALUES ('2','6662','6661','INITIAL','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_internos VALUES ('3','6661','6661','REJECTED','Fua, la lexe que se dieron en una curva','2003-05-06','12:55:00','0','Accidente inventado');
INSERT INTO partes_internos VALUES ('4','6661','6661','VALIDATED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_internos VALUES ('5','6661','6662','VALIDATED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_internos VALUES ('6','6662','6661','VALIDATED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');


INSERT INTO partes_internos VALUES ('7','6662','7772','VALIDATED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_externos VALUES ('1','1','777','6661','INITIAL','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
INSERT INTO partes_externos VALUES ('2','3','777','6661','REJECTED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','Que no!');
INSERT INTO partes_externos VALUES ('3','4','777','6661','VALIDATED','Se pegaron una ostia en guadalquivir','2003-05-06','12:55:00','0','');
