package seguros;

import java.io.*; 
import javax.servlet.*; 
import javax.servlet.http.*; 
import javax.naming.NamingException;

import org.jdom.input.*;
import org.jdom.output.*;

import org.xml.sax.*;
import org.jdom.*;
import java.util.*;
import seguros.excepciones.*;
import java.sql.*;

public class CallCenter extends HttpServlet {
  
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    Document doc = null;
    // Recibir el XML
    SAXBuilder builder = new SAXBuilder();
    try {
      doc = builder.build(request.getInputStream());
    } catch (JDOMException e){
    }
    
    XMLextractor xExtract = new XMLextractor();
    XMLgenerator xGen = new XMLgenerator();
    
    Document result = null;
    try {
      Datos bd = new Datos();
      // Comprobamos que nos estan pidiendo
      String peticion = xExtract.filterRequest(doc);
    
      // NUEVOS PARTES
      if (peticion.equals("notify")){
        FichaParteExterno f = xExtract.notifyRequest(doc);
        
        // Si la poliza se corresponde con una nuestra
        if (bd.polizaValida(f.getPolizaCausante())) {
          // Guardamos en BD
          bd.nuevoParteExterno(f);
          result = xGen.nuevoParteResponseOK();
        } else {
          // Parte no encontrado
          result = xGen.nuevoParteResponseNotFound();
        }
        
      // SOLICITUD DE LISTADO DE PARTES
      } else if (peticion.equals("getStatusList")){
        int poliza = xExtract.policyStatusList(doc);
        // Listamos todos los partes internos donde la poliza indicada es la causante
        
        Collection c = bd.partesStatusList(poliza);
        // Si no ha retornado nada
        if (c.isEmpty()) {
          result = xGen.listarPartesResponseNotFound();
        } else {
          result = xGen.listarPartesResponse(c);
        }
        
      // SOLICITUD DE INFORMACIN DE AGENTE
      } else if (peticion.equals("getContactData")){
        int parte = xExtract.parteContactData(doc);
        ElementoAgente agente = bd.contactData(parte);
        if (agente != null) {
          result = xGen.datosAgenteResponse(agente);
        } else {
          // No ha encontrado el agente/parte
          result = xGen.datosAgenteResponseNotFound();
        }
        
      // CAMBIO DE ESTADO DE UN PARTE
      } else if (peticion.equals("setStatus")){
        String nuevoEstado = xExtract.setStatus(doc);
        
        // Segun cual sea el nuevo estado, el XML sera de una forma o otra
        if (nuevoEstado.equals("RESOLVED")){
          ElementoResolved e = xExtract.setStatusResolved(doc);
          bd.setStatusResolved(e);
          result = xGen.cambioEstadoResponseOK();
        } else if (nuevoEstado.equals("VALIDATED")){
          int parte = xExtract.setStatusValidated(doc);
          bd.setStatusValidated(parte);
          result = xGen.cambioEstadoResponseOK();
        } else if (nuevoEstado.equals("REJECTED")) {
          ElementoRejected e = xExtract.setStatusRejected(doc);
          bd.setStatusRejected(e);
          result = xGen.cambioEstadoResponseOK();
        }
      } else {
        result = xGen.protocoloDesconocido();
      }
      
      
    } catch (NoValido e) {
      // Esta excepcion solo la puede generar bd.setStatusXXXXX(YYY);
      // Significa que desde el estado actual del parte no se puede cambiar al nuevo
      result = xGen.cambioEstadoResponseInvalidStatus();
      // Enviar la respuesta
      XMLOutputter fmt = new XMLOutputter();
      fmt.output(result, response.getOutputStream());
    } catch (NoEncontrado e) {
      // Esta excepcion solo la puede generar bd.setStatusXXXXX(YYY);
      // Significa que no ha encontrado el parte a cambiar de estado
      result = xGen.cambioEstadoResponseNotFound();
      // Enviar la respuesta
      XMLOutputter fmt = new XMLOutputter();
      fmt.output(result, response.getOutputStream());
    } catch (SQLException e) {
      // Esta excepcion solo la puede generar bd
      // Significa que no ha encontrado el parte/agente
      result = xGen.cambioEstadoResponseNotFound();
      // Enviar la respuesta
      XMLOutputter fmt = new XMLOutputter();
      fmt.output(result, response.getOutputStream());
    } catch  (ProtocoloDesconocido e){
      result = xGen.protocoloDesconocido();
      // Enviar la respuesta
      XMLOutputter fmt = new XMLOutputter();
      fmt.output(result, response.getOutputStream());
    } catch (Exception e) {
      result = xGen.protocoloDesconocido();
      // Enviar la respuesta
      XMLOutputter fmt = new XMLOutputter();
      fmt.output(result, response.getOutputStream());
    }
    // Enviar la respuesta
    XMLOutputter fmt = new XMLOutputter();
    fmt.output(result, response.getOutputStream());
  }
  
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doPost(request, response);
  }
  
  
  
  
}
