package seguros;

import seguros.excepciones.*;
import java.sql.*;
import java.util.*;

/**
 * JavaBean del Cliente, la presencia de este JavaBean en la session indicar
 * que el usuario ha sido identificado correctamente.
 */
public class Cliente extends Usuario {
  /**
   * Cambio de password del usuario cliente
   * @param oldPass Password actual.
   * @param newPass Nuevo password.
   * @throws ViejoPassIncorrecto El password actual no coincide con el indicado
   */
  public void setPassword(String oldPass, String newPass) throws SQLException, ViejoPassIncorrecto {
    String sqlLine;
    Connection conexion = obtenerConexion();
    Statement sentencia = conexion.createStatement();
    PreparedStatement ps;
    ResultSet resultado;
    
    sqlLine = "UPDATE clientes SET password = PASSWORD(?) WHERE CL_ID = ? AND password = PASSWORD(?)";      
    ps = conexion.prepareStatement(sqlLine);
    ps.setString(1,newPass);
    ps.setInt(2,id);
    ps.setString(3,oldPass);
    if (ps.executeUpdate() == 0) {
      throw new ViejoPassIncorrecto();
    }
    liberarConexion(conexion);
  }
}