package seguros;

import java.sql.Date;
import java.sql.Time;

/**
 * JavaBean abstracto que se limita simplemente a contener informacin sobre 
 * un Parte. Es la base de un parte interno o externo.
 * 
 * Solo fijarnos que clienteVictima es true cuando la victima pertenece a nuestra compaia
 * igual que clienteCausante sera true si el causante pertenece a nuestra compaia.
 */
public abstract class FichaParte {
  private int id;
  private int polizaCausante;
  private String estado;
  private String descripcion;
  private Date fecha;
  private Time hora;
  private int indemnizacion;
  private String descripcionRechazo;
  // true si la victima es cliente nuestro
  private boolean clienteVictima;
  // true si el causante es cliente nuestro
  private boolean clienteCausante;
  
  FichaParte(int id, int polizaCausante, String estado, String descripcion, Date fecha, Time hora, int indemnizacion, String descripcionRechazo, boolean clienteVictima, boolean clienteCausante) {
    this.id = id;
    this.polizaCausante= polizaCausante;
    this.estado= estado;
    this.descripcion = descripcion;
    this.fecha = fecha;
    this.hora = hora;
    this.indemnizacion = indemnizacion;
    this.descripcionRechazo = descripcionRechazo;
    this.clienteVictima = clienteVictima;
    this.clienteCausante = clienteCausante;
  }
  
  public void setId(int id){
    this.id = id;
  }
  
  public int getId(){
    return id;
  }
  
  
  public void setPolizaCausante(int polizaCausante){
    this.polizaCausante = polizaCausante;
  }
  
  public int getPolizaCausante(){
    return polizaCausante;
  }
  
  public void setEstado(String estado) {
    this.estado = estado;
  }
  
  public String getEstado(){
    return estado;
  }
  
  public void setDescripcion(String descripcion) {
    this.descripcion = descripcion;
  }
  
  public String getDescripcion(){
    return descripcion;
  }
  
  public void setFecha(Date fecha) {
    this.fecha = fecha;
  }
  
  public Date getFecha(){
    return fecha;
  }
  
  public void setHora(Time hora) {
    this.hora = hora;
  }
  
  public Time getHora(){
    return hora;
  }
  
  public void setIndemnizacion(int indemnizacion){
    this.indemnizacion = indemnizacion;
  }
  
  public int getIndemnizacion(){
    return indemnizacion;
  }

  public void setClienteVictima(boolean clienteVictima){
    this.clienteVictima = clienteVictima;
  }
  
  public boolean getClienteVictima(){
    return clienteVictima;
  }
  
  public void setClienteCausante(boolean clienteCausante){
    this.clienteVictima = clienteVictima;
  }
  
  public boolean getClienteCausante(){
    return clienteCausante;
  }
  
  public void setDescripcionRechazo(String descripcionRechazo) {
    this.descripcionRechazo = descripcionRechazo;
  }
  
  public String getDescripcionRechazo(){
    return descripcionRechazo;
  }
  
}
