package seguros;

import seguros.excepciones.*;

/**
 * Tipo de datos que retorna ciertas funciones las cuales tienen que decir
 * con que tipo de usuario estamos tratando.
 */
public class TipoUsuario {
  private boolean cliente=false;
  private boolean agente=false;
  private boolean admin=false;
  
  /**
   * Constructor en el cual se le indica de que tipo de usuario se trata
   * @param tipo nicamente son vlidos "cliente", "agente" o "admin".
   */
  TipoUsuario(String tipo) throws TipoUsuarioIncorrecto {
    if (tipo.equals("cliente")) {
      cliente = true;
    } else if (tipo.equals("agente")) {
      agente = true;
    } else if (tipo.equals("admin")) {
      admin = true;
    } else {
      throw new TipoUsuarioIncorrecto();
    }
  }
  
  /**
   * Consulta si se trata de un cliente
   * @return Booleano
   */
  public boolean esCliente() {
    return cliente;
  }
  
  /**
   * Consulta si se trata de un agente
   * @return Booleano
   */
  public boolean esAgente() {
    return agente;
  }
  
  /**
   * Consulta si se trata de un administrador
   * @return Booleano
   */
  public boolean esAdmin() {
    return admin;
  }
  
}