package seguros;

import seguros.excepciones.*;
import java.sql.*;

import javax.sql.DataSource;
import javax.naming.InitialContext;
import javax.naming.Context;

/**
 * JavaBean Abstracto Usuario, es la base de cualquier usuario del sistema, todos
 * tendran que heredar de aqui.
 */
public abstract class Usuario {
  protected int id;
  protected String idCompania;
  private String login;
  private String nombre;
  private int telf;
  private int dni;
  private String email;
  
  private DataSource ds;

  /**
   * Constructor: Coge una conexin del pool de conexiones
   */
  Usuario() {
    // Pool de conexiones a la BD
    try {
      // Obtain connection
      InitialContext ctx = new InitialContext();
      ds = (DataSource)ctx.lookup("java:comp/env/jdbc/SegurosDB");                                                                                                    
    } catch (Exception e) {
    }
  }
  
  /**
   * Obtiene una conexin del pooling de conexiones a base de datos
   */
  protected Connection obtenerConexion() throws SQLException{
    return ds.getConnection();
  }
  
  /**
   * Libera una conexin para que este disponible en el pooling de conexiones a base de datos
   * @param conexion Conexin a base de datos
   */
  protected void liberarConexion(Connection conexion) throws SQLException{
    conexion.close();
  }
  
  public int getId() {
    return(id);
  }

  public void setId(int id) {
    this.id = id;
  }
  
  public String getIdCompania() {
    return(idCompania);
  }

  public void setIdCompania(String idCompania) {
    this.idCompania = idCompania;
  }
  
  public String getLogin() {
    return(login);
  }

  public void setLogin(String login) {
    this.login = login;
  }
  
  public String getNombre() {
    return(nombre);
  }

  public void setNombre(String nombre) {
    this.nombre = nombre;
  }
  
  public int getTelf() {
    return(telf);
  }

  public void setTelf(int telf) {
    this.telf = telf;
  }
  
  public int getDni() {
    return(dni);
  }

  public void setDni(int dni) {
    this.dni = dni;
  }
  
  public String getEmail() {
    return(email);
  }

  public void setEmail(String email) {
    this.email = email;
  }
  
}