
import java.util.*;
import java.net.*;
import java.io.*;

public class ChatClient {
  boolean conectado = false;
  BufferedReader	entrada;
  PrintStream salida;
  ClientThread controlador;
  Vector lista;
  
  public void join(String user,String ip, int port) throws UnknownHostException, IOException {
    if (! conectado) {
      Socket socket = new Socket(ip,port);
      OutputStream out = socket.getOutputStream();
      InputStream in = socket.getInputStream();
      entrada = new BufferedReader(new InputStreamReader(in));
      salida = new PrintStream(out);
      
      lista = new Vector();
      controlador = new ClientThread(entrada,lista);
      controlador.start();
      
      // Le decimos el nick
      salida.println(user);
      conectado=true;
      
    }
    
  }
  
  public void leave(){
    if (conectado) {
      salida.println("quit");
      conectado = false;
    }
  }
  
  public void say(String msg){
    if (conectado) {
      salida.println(msg);
    }
  }
  
  public void addChatListener(ChatListener theListener){
    lista.add(theListener);
  }
  
  public void removeChatListener(ChatListener theListener){
    lista.remove(theListener);
  }
  

}
